// AMIS30624 Micro-Stepper (actuator) 
// Arduino Library
//
//
// May 15, 2011 - initial release
//
// CC = BY NC SA
// http://sites.google.com/site/vilorei/
//

#include <Wire.h>
#include "I2C_Stepper.h"

I2C_Stepper myStepper2(0);


void setup() {
  Serial.begin(19200);

  Wire.begin();
  Serial.print("\n\n\n***\n");
  myStepper2.begin();
  myStepper2.setParameters();

  Serial.println("Micro-Stepper Controller");
  Serial.println();
  Serial.println(myStepper2.WhoAmI());

}

void help() {
  Serial.println("r: go to Reference");
  Serial.println("z: define Zero");
  Serial.println("a: go to position A");
  Serial.println("b: go to position B");
  Serial.println("b: go to position C");
  Serial.println("s: go to Secure position");
  Serial.println("g: Get status");
  Serial.println("p: set Parameters");
  Serial.println("n: reset positioN");
  Serial.println("x: eXit");
}


void loop() {
  byte command;

  Serial.println();
  help();

  while (Serial.available()==0);  // Look for char in serial que and process if found
  command = Serial.read();

  Serial.print("Command :");
  Serial.print(command);
  Serial.print("\n");

  if (command=='g') {  
    myStepper2.getStatus();
    Serial.print("testPumpFailure"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testPumpFailure(), HEX);
    Serial.print("\n");
    Serial.print("testElectricalDefect"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testElectricalDefect(), HEX);
    Serial.print("\n");
    Serial.print("testReferenceReached"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testReferenceReached(), HEX);
    Serial.print("\n");
    Serial.print("testMotion"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testMotion(), HEX);
    Serial.print("\n");
    Serial.print("testStop"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testStop(), HEX);
    Serial.print("\n");
    Serial.print("testOverCurrent"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testOverCurrent(), HEX);
    Serial.print("\n");
    Serial.print("testOverCurrentX"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testOverCurrentX(), HEX);
    Serial.print("\n");
    Serial.print("testOverCurrentY"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testOverCurrentY(), HEX);
    Serial.print("\n");
    Serial.print("testStepLoss"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testStepLoss(), HEX);
    Serial.print("\n");
    Serial.print("testStall"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testStall(), HEX);
    Serial.print("\n");
    Serial.print("testThermalShutDown"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testThermalShutDown(), HEX);
    Serial.print("\n");
    Serial.print("testThermalWarning"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testThermalWarning(), HEX);
    Serial.print("\n");
    Serial.print("testTemperatureInfo"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testTemperatureInfo());
    Serial.print("\n");
    Serial.print("testBatteryUnderVoltage"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testBatteryUnderVoltage(), HEX);
    Serial.print("\n");
    Serial.print("testDigitalVoltageReset"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testDigitalVoltageReset(), HEX);
    Serial.print("\n");
    Serial.print("testError"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.testError(), HEX);
    Serial.print("\n");  

    Serial.print("actualPosition"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.actualPosition(), DEC);
    Serial.print("\n");
    Serial.print("targetPosition"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.targetPosition(), DEC);
    Serial.print("\n");
    Serial.print("securePosition"); 
    Serial.print("\t"); 
    Serial.print(myStepper2.securePosition(), DEC);
    Serial.print("\n");
  } 


  if (command=='r') {  
    myStepper2.goReference();
    myStepper2.setParameters();

  } 

  else if (command=='n') {  
  myStepper2.resetPosition();
  }

  else if (command=='z') {  
    Serial.print("\ngo 1200\n");
    myStepper2.goPosition(1200);

    do {
      myStepper2.getStatus();
      Serial.print(myStepper2.testMotion(), HEX);
      Serial.print("\t");
      Serial.print(myStepper2.testStop(), HEX);
      Serial.print("\n");
    } 
    while (!myStepper2.testStop());

    myStepper2.resetPosition();

    //    myStepper2.hardStop();

  } 
  else if (command=='a') {  
    Serial.print("\ngo 20000\n");
    myStepper2.goPosition(20000);

    do {
      myStepper2.getStatus();
      Serial.print(myStepper2.actualPosition(), DEC);
      Serial.print("\t");
      Serial.print(myStepper2.targetPosition(), DEC);
      Serial.print("\t");
      Serial.print(myStepper2.testStop(), HEX);
      Serial.print("\n");
    } 
    while (!myStepper2.testStop());

  } 
  else if (command=='b') {  
    Serial.print("\ngo 12000\n");
    myStepper2.goPosition(12000);

    do {
      myStepper2.getStatus();
      Serial.print(myStepper2.actualPosition(), DEC);
      Serial.print("\t");
      Serial.print(myStepper2.targetPosition(), DEC);
      Serial.print("\t");
      Serial.print(myStepper2.testStop(), HEX);
      Serial.print("\n");
    } 
    while (!myStepper2.testStop());
  }
  else if (command=='c') {  
    Serial.print("\ngo -200\n");
    myStepper2.goPosition(-200);

    do {
      myStepper2.getStatus();
      Serial.print(myStepper2.actualPosition(), DEC);
      Serial.print("\t");
      Serial.print(myStepper2.targetPosition(), DEC);
      Serial.print("\t");
      Serial.print(myStepper2.testStop(), HEX);
      Serial.print("\n");
    } 
    while (!myStepper2.testStop());

  } 
  else if (command=='s') {  
    Serial.print("\ngo secure\n");
    myStepper2.goSecurePosition();
    do {
      myStepper2.getStatus();
      Serial.print(myStepper2.actualPosition(), DEC);
      Serial.print("\t");
      Serial.print(myStepper2.targetPosition(), DEC);
      Serial.print("\t");
      Serial.print(myStepper2.testStop(), HEX);
      Serial.print("\n");
    } 
    while (!myStepper2.testStop());

  }

  else if (command=='p') {  
    myStepper2.setParameters();

  }

  else if (command=='x') {  
    myStepper2.hardStop();

  }

  command=0x00;
}








